#include <imsls.h>

#define INTERCEPT       1
#define N_INDEPENDENT   3
#define N_DEPENDENT     2
#define N_COEFFICIENTS  (INTERCEPT + N_INDEPENDENT)
#define N_OBSERVATIONS  9

main()
{
    float  coefficients[N_DEPENDENT*N_COEFFICIENTS];
    float  *dummy;
    float  scpe[N_DEPENDENT*N_DEPENDENT];
    float  anova_table[15*N_DEPENDENT];
    static float   x[] =       { 7.0, 5.0, 6.0,  7.0,  1.0, 
                                 2.0,-1.0, 6.0, -5.0,  4.0, 
                                 7.0, 3.0, 5.0,  6.0, 10.0, 
                                -3.0, 1.0, 4.0,  5.0,  5.0, 
                                 2.0,-1.0, 0.0,  5.0, -2.0, 
                                 2.0, 1.0, 7.0, -2.0,  4.0, 
                                -3.0,-1.0, 3.0,  0.0, -6.0, 
                                 2.0, 1.0, 1.0,  8.0,  2.0, 
                                 2.0, 1.0, 4.0,  3.0,  0.0};
    int    ifrq = -1, iwt=-1;
    static int indind[N_INDEPENDENT] = {0, 1, 2};
    static int inddep[N_DEPENDENT] = {3, 4};
    char   *fmt = "%10.4f";
    char   *anova_row_labels[] = {
                   "d.f. regression", 
                   "d.f. error", 
                   "d.f. total (uncorrected)",
                   "ssr", 
                   "sse", 
                   "sst (uncorrected)",
                   "msr", 
                   "mse", "F-statistic",
                   "p-value", "R-squared (in percent)", 
                   "adj. R-squared (in percent)",
                   "est. s.t.d. of model error", 
                   "overall mean of y", 
                   "coefficient of variation (in percent)"};

    imsls_f_regression(N_OBSERVATIONS, N_INDEPENDENT, 
        (float *) x, dummy,
        IMSLS_X_COL_DIM, N_INDEPENDENT+N_DEPENDENT,
        IMSLS_N_DEPENDENT, N_DEPENDENT, 
        IMSLS_X_INDICES, indind, inddep, ifrq, iwt,
        IMSLS_SCPE_USER, scpe, 
        IMSLS_ANOVA_TABLE_USER, anova_table,
        IMSLS_RETURN_USER, coefficients,
        0);

    imsls_f_write_matrix("Least Squares Coefficients", N_DEPENDENT,
        N_COEFFICIENTS, coefficients, 
        IMSLS_COL_NUMBER_ZERO, 0);

    imsls_f_write_matrix("SCPE", N_DEPENDENT, N_DEPENDENT, scpe, 
        IMSLS_WRITE_FORMAT, "%10.4f", 0);

    imsls_f_write_matrix("* * * Analysis of Variance * * *\n", 
        15, N_DEPENDENT, 
        anova_table,
        IMSLS_ROW_LABELS, anova_row_labels,
        IMSLS_WRITE_FORMAT, "%10.2f", 
        0);


}
